import java.io.*;
import java.util.*;

public class game_sk implements Runnable {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new game_sk()).start();
	}
	
	StringTokenizer st;
	BufferedReader in;
	PrintWriter out;
	final String FILE = "game";
	
	String nextToken() throws IOException {
		while ((st == null) || (!st.hasMoreTokens())) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	public void run() {
		try {
			in = new BufferedReader(new FileReader(FILE + ".in"));
			out = new PrintWriter(FILE + ".out");
			solution();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
	
	long[] d;
	
	long get(int f, int l) {
		d = new long[n];
		Arrays.fill(d, Long.MAX_VALUE);
		TreeSet<Integer> q = new TreeSet<Integer>(new Comparator<Integer>() {
			@Override
			public int compare(Integer o1, Integer o2) {
				if (d[o1] > d[o2]) {
					return 1;
				}
				if (d[o1] < d[o2]) {
					return -1;
				}
				return o1 - o2;
			}
		});
		d[f] = 0;
		q.add(f);
		
		while (q.size() != 0) {
			int t = q.first();
			q.remove(t);
			
			for (int i = 0; i < r[t].size(); i++) {
				int j = r[t].get(i);
				int c = rc[t].get(i);
				if (d[j] > d[t] + c) {
					q.remove(j);
					d[j] = d[t] + c;
					q.add(j);
				}
			}
		}
		
		return d[l];
	}
	
	int n;
	List<Integer>[] r;
	List<Integer>[] rc;
	
	void solution() throws Exception {
		n = nextInt();
		int m = nextInt();
		
		r = new List[n];
		rc = new List[n];
		for (int i = 0; i < n; i++) {
			r[i] = new ArrayList<Integer>();
			rc[i] = new ArrayList<Integer>();
		}
		
		for (int i = 0; i < m; i++) {
			int a = nextInt() - 1;
			int b = nextInt() - 1;
			int c = nextInt();
			
			r[a].add(b);
			rc[a].add(c);
			
			r[b].add(a);
			rc[b].add(c);
		}
		
		int s1 = nextInt() - 1;
		int s2 = nextInt() - 1;
		int t = nextInt() - 1;
		
		long g1 = get(s1, t);
		long g2 = get(s2, t);
		
		if (g1 <= g2) {
			out.println("First");
		} else {
			out.println("Second");
		}
		
	}
}